package io.testcase.model;

import org.orekit.time.DateTimeComponents;

public class PayLoadUsable {

  private SeeingStatus seeingStatus;

  private boolean timeIsWithinBoundaries;

  private DateTimeComponents localDateTime;

  private DateTimeComponents dateTimeInUtc;

  public PayLoadUsable() {
  }

  public PayLoadUsable(SeeingStatus seeingStatus, boolean timeIsWithinBoundaries, DateTimeComponents localDateTime, DateTimeComponents dateTimeInUtc) {
    this.seeingStatus = seeingStatus;
    this.timeIsWithinBoundaries = timeIsWithinBoundaries;
    this.localDateTime = localDateTime;
    this.dateTimeInUtc = dateTimeInUtc;
  }

  public static PayLoadUsableBuilder builder() {
    return new PayLoadUsableBuilder();
  }

  public SeeingStatus getSeeingStatus() {
    return this.seeingStatus;
  }

  public boolean isTimeIsWithinBoundaries() {
    return this.timeIsWithinBoundaries;
  }

  public DateTimeComponents getLocalDateTime() {
    return this.localDateTime;
  }

  public DateTimeComponents getDateTimeInUtc() {
    return this.dateTimeInUtc;
  }

  public void setSeeingStatus(SeeingStatus seeingStatus) {
    this.seeingStatus = seeingStatus;
  }

  public void setTimeIsWithinBoundaries(boolean timeIsWithinBoundaries) {
    this.timeIsWithinBoundaries = timeIsWithinBoundaries;
  }

  public void setLocalDateTime(DateTimeComponents localDateTime) {
    this.localDateTime = localDateTime;
  }

  public void setDateTimeInUtc(DateTimeComponents dateTimeInUtc) {
    this.dateTimeInUtc = dateTimeInUtc;
  }

  public boolean equals(final Object o) {
    if (o == this) return true;
    if (!(o instanceof PayLoadUsable)) return false;
    final PayLoadUsable other = (PayLoadUsable) o;
    if (!other.canEqual((Object) this)) return false;
    final Object this$seeingStatus = this.getSeeingStatus();
    final Object other$seeingStatus = other.getSeeingStatus();
    if (this$seeingStatus == null ? other$seeingStatus != null : !this$seeingStatus.equals(other$seeingStatus)) return false;
    if (this.isTimeIsWithinBoundaries() != other.isTimeIsWithinBoundaries()) return false;
    final Object this$localDateTime = this.getLocalDateTime();
    final Object other$localDateTime = other.getLocalDateTime();
    if (this$localDateTime == null ? other$localDateTime != null : !this$localDateTime.equals(other$localDateTime)) return false;
    final Object this$dateTimeInUtc = this.getDateTimeInUtc();
    final Object other$dateTimeInUtc = other.getDateTimeInUtc();
    if (this$dateTimeInUtc == null ? other$dateTimeInUtc != null : !this$dateTimeInUtc.equals(other$dateTimeInUtc)) return false;
    return true;
  }

  protected boolean canEqual(final Object other) {
    return other instanceof PayLoadUsable;
  }

  public int hashCode() {
    final int PRIME = 59;
    int result = 1;
    final Object $seeingStatus = this.getSeeingStatus();
    result = result * PRIME + ($seeingStatus == null ? 43 : $seeingStatus.hashCode());
    result = result * PRIME + (this.isTimeIsWithinBoundaries() ? 79 : 97);
    final Object $localDateTime = this.getLocalDateTime();
    result = result * PRIME + ($localDateTime == null ? 43 : $localDateTime.hashCode());
    final Object $dateTimeInUtc = this.getDateTimeInUtc();
    result = result * PRIME + ($dateTimeInUtc == null ? 43 : $dateTimeInUtc.hashCode());
    return result;
  }

  public String toString() {
    return "PayLoadUsable(seeingStatus=" + this.getSeeingStatus() + ", timeIsWithinBoundaries=" + this.isTimeIsWithinBoundaries() + ", localDateTime=" + this.getLocalDateTime() + ", dateTimeInUtc=" + this.getDateTimeInUtc() + ")";
  }

  public enum SeeingStatus {
    START,
    END
  }

  public static class PayLoadUsableBuilder {
    private SeeingStatus seeingStatus;
    private boolean timeIsWithinBoundaries;
    private DateTimeComponents localDateTime;
    private DateTimeComponents dateTimeInUtc;

    PayLoadUsableBuilder() {
    }

    public PayLoadUsableBuilder seeingStatus(SeeingStatus seeingStatus) {
      this.seeingStatus = seeingStatus;
      return this;
    }

    public PayLoadUsableBuilder timeIsWithinBoundaries(boolean timeIsWithinBoundaries) {
      this.timeIsWithinBoundaries = timeIsWithinBoundaries;
      return this;
    }

    public PayLoadUsableBuilder localDateTime(DateTimeComponents localDateTime) {
      this.localDateTime = localDateTime;
      return this;
    }

    public PayLoadUsableBuilder dateTimeInUtc(DateTimeComponents dateTimeInUtc) {
      this.dateTimeInUtc = dateTimeInUtc;
      return this;
    }

    public PayLoadUsable build() {
      return new PayLoadUsable(seeingStatus, timeIsWithinBoundaries, localDateTime, dateTimeInUtc);
    }

    public String toString() {
      return "PayLoadUsable.PayLoadUsableBuilder(seeingStatus=" + this.seeingStatus + ", timeIsWithinBoundaries=" + this.timeIsWithinBoundaries + ", localDateTime=" + this.localDateTime + ", dateTimeInUtc=" + this.dateTimeInUtc + ")";
    }
  }
}
